
library(bsicons)
ui <- function() {
  page_fillable(
    h1("Kriminalstatistik Hamburg",
       style = "color: #003063; font-weight: bold;",
       class = "ms-4 display-4"),# ms-4 sorgt für den Abstand links
    navset_card_tab(
      nav_panel("Karte",
                page_sidebar(
                  layout_columns(
                    leafletOutput("hhmap"),
                    card(
                      div(
                        # h3 oder div dient als Block-Element und richtet seinen Inhalt (das span) rechtsbündig aus
                        style = "text-align: right; width: 100%; ", 
                        
                        # Der Text wird in ein span verpackt und erhält die Border. 
                        # Ein span nimmt nur den Platz ein, den der Inhalt benötigt (inline).
                        tags$span(
                          "2024", 
                          style = "
                    border: 1px solid rgba(40,70,94,0.1);
                    border-radius: 5px;
                    padding: 5px 10px 5px 10px;
                    background-color: #eeeeee;
                  "
                          # padding ist der abstand an leerer Fläche in der reihenfolge top right bottom left
                          # farbe rgba ist die exakte Farbe der Trennlinien und Card-Umrandungen aus der App
                        )
                      ),
                      div(
                        class = "d-flex align-items-end gap-2",
                        h5(strong("Bezirk:"), style = "margin-bottom: 0;"),
                        textOutput("txt_map_selection_bezirk"),
                      ),
                      div(
                        class = "d-flex align-items-end gap-2",
                        h5(strong("Stadtteil:"), style = "margin-bottom: 0;"),
                        textOutput("txt_map_selection_stadtteil"),
                      ),
                      plotOutput("grph_top3"),
                      #tableOutput("tbl_2024"),
                    ),
                    col_widths = c(8, 4),
                  ),
                  sidebar = sidebar(
                    radioButtons(
                      inputId = "rd_maptype",
                      label = "Kartentyp",
                      choices = c("Bezirke", "Stadtteile"),
                      selected = "Bezirke"
                    ),
                    selectizeInput(
                      inputId = "search",
                      label = tags$span(icon("search"),"Suche"),
                      choices = NULL, 
                      selected = NULL, 
                      multiple = FALSE, # Hier wahrscheinlich nur Einzelauswahl gewünscht
                      options = list(
                        placeholder = "Anfangen zu tippen...",
                        openOnFocus = FALSE,
                        allowEmptyOption = TRUE,
                        selectOnTab = FALSE,
                        plugins = list('dropdown_header')
                      )
                    ),
                    div(
                      tags$h5("Heatmap zur Häufigkeit der Straftaten:", style = "font-weight: bold; margin-bottom: 10px;"),                   
                      selectizeInput(
                        inputId = "heatmap",
                        label = "Wähle eine Straftat:",
                        choices = list_of_crimes,
                        selected = NULL,
                        options = list(
                          placeholder = "Keine Auswahl",
                          plugins = list('clear_button')
                        )
                      )
                    )
                  ),
                )
      ),
      nav_panel("Vergleich", 
                layout_sidebar(
                  sidebar = sidebar(
                    title = "Vergleichs-Optionen",
                    radioButtons(
                      "vergleichs_modus",
                      "Wählen Sie den Vergleichstyp:",
                      choices = c(
                        "Straftat vs. Orte" = "ort_vergleich",
                        "Ort vs. Straftaten" = "straftat_vergleich"
                      ),
                      selected = "ort_vergleich"
                    ),
                    
                    tags$hr(),
                    
                    # 2. Dynamische Input-Felder für die Orte und Straftaten
                    uiOutput("vergleichs_inputs"),
                    
                    # 3. Gemeinsamer Input: Das Jahr
                    selectizeInput(
                      "vergleichs_jahr", 
                      "Jahr wählen:", 
                      choices = c(2024, 2023), 
                      selected = 2024
                    ),
                  ),
                  card(
                    card_header(uiOutput("vergleichs_titel")), # Dynamischer Titel
                    plotOutput("vergleichs_plot")
                  )
                )
      ),
      
      
      
      
      nav_panel("Wiki", 
                accordion(
                  accordion_panel(
                    title = "Raub, räuberische Erpressung, räuberischer Angriff auf Kraftfahrer",
                    card(
                      card_header(
                        h4(bs_icon("cash-stack"), 
                           "Raub nach § 249 StGB")
                      ),
                      p("Raubdelikte nach § 249 des deutschen Strafgesetzbuch sind Straftaten, bei denen jemand eine fremde bewegliche Sache wegnimmt, indem er Gewalt anwendet oder mit Gewalt droht, um sie sich oder einem Dritten rechtswidrig zuzueignen."),
                      tags$blockquote(
                        class = "blockquote",
                        "(1) Wer mit Gewalt gegen eine Person oder unter Anwendung von Drohungen mit gegenwärtiger Gefahr für Leib oder Leben eine fremde bewegliche Sache einem anderen in der Absicht wegnimmt, die Sache sich oder einem Dritten rechtswidrig zuzueignen, wird mit Freiheitsstrafe nicht unter einem Jahr bestraft.",
                        tags$br(), #Zeilenumbruch
                        "(2) In minder schweren Fällen ist die Strafe Freiheitsstrafe von sechs Monaten bis zu fünf Jahren."
                      )
                    ),
                    card(
                      card_header(
                        h4(icon("money-bill-transfer"),
                           "Räuberische Erpressung nach § 255 StGB")
                      ),
                      p("Räuberische Erpressung (§ 255 StGB) ist eine
              schwere Form der Erpressung, bei der Gewalt gegen eine Person oder die Drohung mit gegenwärtiger Lebens- oder Gesundheitsgefahr eingesetzt wird, um eine Vermögensverfügung zu erzwingen, wodurch der Täter wie ein Räuber (§ 249 StGB) bestraft wird, also mit mindestens einem Jahr Freiheitsstrafe."),
                      tags$blockquote(
                        class = "blockquote",
                        "Wird die Erpressung durch Gewalt gegen eine Person oder unter Anwendung von Drohungen mit gegenwärtiger Gefahr für Leib oder Leben begangen, so ist der Täter gleich einem Räuber zu bestrafen."
                      )
                      
                    )
                  ),
                  accordion_panel(
                    title = "Gewaltkriminalität",
                    #icon =
                    "Gewaltkriminalität ist doof."
                  ),
                  accordion_panel(
                    title = "Was ganz langes.",
                    #icon
                    "Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat, sed diam voluptua. At vero eos et accusam et justo duo dolores et ea rebum. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet. Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat, sed diam voluptua. At vero eos et accusam et justo duo dolores et ea rebum. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet."
                  )
                )
      ),
      id = "tab"
    )
  )
}